# frozen_string_literal: true

$LOAD_PATH.unshift("#{File.dirname(__FILE__)}/lib")
require 'securerandom'
require 'landline'
require 'landline/util/cookie'
require 'irb'

KEY = SecureRandom.base64(64).freeze

app = Landline::Server.new do
  get "/set-cookie" do
    cookie "test", (rand * 500).floor.to_s, { hmac: KEY }
    header "content-type", "text/plain"
    "Cookie set! Visit /get-cookie to view it"
  end
  get "/get-cookie" do
    header "content-type", "text/plain"
    if request.cookies.dig('test', 0)&.verify(KEY)
      "Cookie is valid and generated by server"
    else
      "Cookie either doesn't exist or is forged"
    end
  end
end

run app
