# frozen_string_literal: true

$LOAD_PATH.unshift("#{File.dirname(__FILE__)}/lib")
require 'landline'

app = Landline::Server.new do
  get "/hello" do
    header "content-type", "text/plain"
    "Hello World!"
  end
  get "/error" do
    raise StandardError, "I raised an error! (and that's very sad)"
  end
  handle do |status, backtrace: nil|
    page = ([Landline::Util::HTTP_STATUS[status]] +
            (backtrace || [""])).join("\n")
    [
      {
        "content-length": page.bytesize,
        "content-type": "text/plain"
      },
      page
    ]
  end
end

run app
