# frozen_string_literal: true

$LOAD_PATH.unshift("#{File.dirname(__FILE__)}/lib")
require_relative '../lib/landline'

# @!parse include ::Landline::DSL::PathConstructors
# @!parse include ::Landline::DSL::PathMethods

app = Landline::Server.new do
  postprocess do |request, response|
    puts response.class
  end

  get "/hijack" do
    # @!parse include ::Landline::DSL::ProbeMethods
    if request.hijack?
      partial_hijack do |stream|
        sec = (rand * 20).floor
        sleep(sec)
        stream << <<~DOC
          <!DOCTYPE html>
          <HTML>
            <HEAD>
              <TITLE>You have been delayed, bozo!</TITLE>
            </HEAD>
            <BODY>
              <H1>Get delayed, dumbass!</H1>
              <P>Imagine getting delayed for like, what, #{sec} seconds? LMAO</P>
            </BODY>
          </HTML>
        DOC
        stream.flush
        stream.close
      end
      next ''
    else
      header "content-type", "text/plain"
      next 'No partial hijacking for you :('
    end
  end
end

run app
