# frozen_string_literal: true

require 'landline/extensions/session'
require 'landline'

Landline::Session.hmac_secret = "Your secure signing secret here"

app = Landline::Server.new do
  get "/make_cookie" do
    session["random_number"] = Random.random_number(100)
    <<~HTML
      <!DOCTYPE html>
      <html>
        <head>
          <title>
            Session test
          </title>
        </head>
        <body>
          <h1>Your random number has been created!</h1>
          <hr>
          <p>Go check it at <a href="/check_cookie">this link!</a></p>
        </body>
      </html>
    HTML
  end

  get "/check_cookie" do
    if session["random_number"]
      <<~HTML
        <!DOCTYPE html>
        <html>
          <head>
            <title>
              Session test
            </title>
          </head>
          <body>
            <h1>Your random number is...</h1>
            <hr>
            <p>#{session['random_number']}! Enjoy your random magic number!</p>
          </body>
        </html>
      HTML
    else
      <<~HTML
        <!DOCTYPE html>
        <html>
          <head>
            <title>
              Session test
            </title>
          </head>
          <body>
            <h1>Uh oh!</h1>
            <hr>
            <p>Go get your magic number at <a href="/make_cookie">this link!</a></p>
          </body>
        </html>
      HTML
    end
  end
end

run app
