# frozen_string_literal: true

$LOAD_PATH.unshift("#{File.dirname(__FILE__)}/lib")
require 'landline'

app = Landline::Server.new do
  root ENV["PWD"]
  index ["index.html"]
  post "/" do
    formdata = form if form?
    files = {}
    if formdata
      formdata["form_files"].each do |file|
        filename = file.filename.split("/").last
        `mv #{file.tempfile.path} $PWD/files/#{filename}`
        files[file.filename] = "<a href=\"files/#{filename}\">#{filename}</a>"
      end
    end
    erubi(file("index.rhtml"), { formdata: files }).run
  end
  serve "/files/*"
  get "/" do
    erubi(file("index.rhtml")).run
  end
end

run app
