# frozen_string_literal: true

module Landline
  # Rack application interface
  class App
    # TODO: fix this mess somehow (probably impossible)

    # @!parse include Landline::DSL::PathMethods
    # @!parse include Landline::DSL::PathConstructors
    # @!parse include Landline::DSL::ProbeConstructors
    # @!parse include Landline::DSL::ProbeMethods
    # @!parse include Landline::DSL::CommonMethods
    class << self
      # Duplicate used middleware for the subclassed app
      def inherited(subclass)
        super(subclass)
        subclass.middleware = @middleware.dup
      end

      # Include a middleware in application
      # @param middleware [Class]
      def use(middleware)
        @middleware ||= []
        @middleware.append(middleware)
      end

      # Setup block
      # @param block [#call]
      def setup(&block)
        @setup_block = block
      end

      attr_accessor :middleware, :setup_block
    end

    def initialize(*args, **opts)
      @app = ::Landline::Server.new(*args, **opts, &self.class.setup_block)
      self.class.middleware&.reverse_each do |cls|
        @app = cls.new(@app)
      end
    end

    # Rack ingress point.
    # @param env [Hash]
    # @return [Array(Integer,Hash,Array)]
    def call(env)
      @app.call(env)
    end
  end
end
