# frozen_string_literal: true

require 'erb'
require 'securerandom'

module Landline
  module DSL
    # Common methods for template contexts
    module TemplateMethods
      # (in Landline::Template context)
      # Import a template part
      # @param filepath [String, File] path to the file (or the file itself)
      # @return [String] compiled template
      def import(filepath)
        template = if filepath.is_a? File
                     filepath
                   elsif filepath.start_with? "/"
                     File.open(filepath)
                   else
                     file(filepath)
                   end
        @parent_template.import(template).run
      end
    end
  end
end
