# frozen_string_literal: true

require 'erb'
require_relative '../template'

module Landline
  module Templates
    # ERB Template language adapter
    class ERB < Landline::Template
      # (see Landline::Template#new)
      def initialize(input, vars = nil, parent:, filename:)
        super
        varname = "_part_#{SecureRandom.hex(10)}".to_sym
        while @binding.local_variable_defined? varname
          varname = "_part_#{SecureRandom.hex(10)}".to_sym
        end
        @template = ::ERB.new(@template, eoutvar: varname)
        @template.filename = input.is_a?(File) ? input.path : "(Inline)"
      end

      # Run the template.
      def run
        @template.filename = @filename
        @template.result @binding
      end
    end
  end
end
